> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/core/page-manipulation/split.md).

# Split PDF pages on Server/Desktop

Learn how to split a PDF document into multiple pages with code examples for merging, copying, deleting, and rearranging PDF pages. Explore the ImportPages function. The Apryse Server SDK streamlines

{% hint style="info" %}
**Requirements**

Packages are required for production license. Trial keys have unlimited access to all features.

Demo showcases functionality using WebViewer UI.

<a href="https://apryse.com/capabilities#PageManipulation" class="button primary">Package: Page Manipulation</a><a href="https://showcase.apryse.com/create-thumbnail" class="button primary">Live demo</a>
{% endhint %}

To split a PDF document into multiple pages.

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
PDFDoc doc = new PDFDoc(filename);
int page_num = doc.GetPageCount();
for (int i = 1; i <= page_num; ++i)
{
    PDFDoc new_doc = new PDFDoc();
    new_doc.InsertPages(0, doc, i, i, PDFDoc.InsertFlag.e_none);
    new_doc.Save(output_filename + "_split_page_" + i + ".pdf", SDFDoc.SaveOptions.e_linearized);
}
```

{% endcode %}
{% endtab %}

{% tab title="C++" %}
{% code lineNumbers="true" %}

```cpp
PDFDoc doc(filename);
int page_num = doc.GetPageCount();
for (int i=1; i<=page_num; ++i)
{
  PDFDoc new_doc;
  char fname[64];
  sprintf(fname, "_split_page_%d.pdf", i);
  string output_file(output_filename + fname);
  new_doc.InsertPages(0, doc, i, i, PDFDoc::e_none);
  new_doc.Save(output_file, SDFDoc::e_linearized, 0);
}
```

{% endcode %}
{% endtab %}

{% tab title="Go" %}
{% code lineNumbers="true" %}

```go
doc := NewPDFDoc(filename)
pageNum = doc.GetPageCount()
for i := 1; i <= pageNum; i ++ {
    newDoc.InsertPages(0, doc, i, i, PDFDocE_none)
    newDoc.Save(outputPath + "_split_page_" + i + ".pdf", uint(SDFDocE_linearized))
    newDoc.Close()
}
```

{% endcode %}
{% endtab %}

{% tab title="Java" %}
{% code lineNumbers="true" %}

```java
PDFDoc doc = new PDFDoc(filename);
int page_num = doc.getPageCount();
for (int i=1; i<=page_num; ++i)
{
  PDFDoc new_doc = new PDFDoc();
  new_doc.insertPages(0, doc, i, i, PDFDoc.InsertBookmarkMode.NONE, null);
  new_doc.save(output_filename + "_split_page_" + i + ".pdf", SDFDoc.SaveMode.LINEARIZED, null);
  new_doc.close();
}
```

{% endcode %}
{% endtab %}

{% tab title="JavaScript" %}
{% code lineNumbers="true" %}

```js
async function main() {
  const doc = await PDFNet.PDFDoc.createFromURL(filename);
  const page_num = await doc.getPageCount();
  for (let i=1; i<=page_num; ++i)
  {
    const newDoc = await PDFNet.PDFDoc.create();
    newDoc.insertPages(0, doc, i, i, PDFNet.PDFDoc.InsertFlag.e_none);
    const buf = await newDoc.saveMemoryBuffer(PDFNet.SDFDoc.SaveOptions.e_linearized);

    //optionally save the blob to a file or upload to a server
    const blob = new Blob([buf], { type: 'application/pdf' });
  }
}
PDFNet.runWithCleanup(main);
```

{% endcode %}
{% endtab %}

{% tab title="Kotlin" %}
{% code lineNumbers="true" %}

```kotlin
val doc = PDFDoc(filename)
val page_num = doc.getPageCount();
for (i in 1..page_num)
{
  val new_doc = PDFDoc()
  new_doc.insertPages(0, doc, i, i, PDFDoc.InsertBookmarkMode.NONE, null)
  new_doc.save(output_filename + "_split_page_" + i + ".pdf", SDFDoc.SaveMode.LINEARIZED, null)
  new_doc.close()
}
```

{% endcode %}
{% endtab %}

{% tab title="Obj-C" %}
{% code lineNumbers="true" %}

```objc
PTPDFDoc *doc = [[PTPDFDoc alloc] initWithFilepath: filename];
int page_num = [doc GetPageCount];
for (int i=1; i<=page_num; ++i)
{
  PTPDFDoc *new_doc = [[PTPDFDoc alloc] init];
  [new_doc InsertPages: 0 src_doc: doc start_page: i end_page: i flag: e_ptinsert_none];
  [new_doc SaveToFile: [output_filename stringByAppendingFormat: @"_split_page_%d.pdf", i] flags: e_ptlinearized];
}
```

{% endcode %}
{% endtab %}

{% tab title="Swift" %}
{% code lineNumbers="true" %}

```swift
let doc: PTPDFDoc = PTPDFDoc(filepath: filename)

let page_num = doc.getPageCount()
for i in 1..page_num
{
  let new_doc: PTPDFDoc = PTPDFDoc()
  let output_file: String = "\(output_filename)_split_page_\(i).pdf"
  new_doc.insertPages(0, src_doc: doc, start_page: i, end_page: i, flag: e_ptinsert_none)
  new_doc.save(toFile: output_file, flags: e_ptlinearized.rawValue)
}
```

{% endcode %}
{% endtab %}

{% tab title="PHP" %}
{% code lineNumbers="true" %}

```php
$doc = new PDFDoc($filename);
$page_num = $doc->GetPageCount();
for ($i = 1; $i <= $page_num; ++$i)
{
  $new_doc = new PDFDoc();
  $new_doc->InsertPages(0, $doc, $i, $i, PDFDoc::e_none);
  $new_doc->Save($output_filename."_split_page_".$i.".pdf", SDFDoc::e_linearized);
  $new_doc->Close();
}
```

{% endcode %}
{% endtab %}

{% tab title="Python" %}
{% code lineNumbers="true" %}

```python
doc = PDFDoc(filename)

page_num = doc.GetPageCount()
for i in range(1, page_num):
  new_doc=PDFDoc()
  new_doc.InsertPages(0, doc, i, i, PDFDoc.e_none)
  new_doc.Save(output_filename + "_split_page_" + str(i) + ".pdf", SDFDoc.e_linearized)
  new_doc.Close()
```

{% endcode %}
{% endtab %}

{% tab title="Ruby" %}
{% code lineNumbers="true" %}

```ruby
doc = PDFDoc.new(filename)
page_num = doc.GetPageCount()
for i in 1..page_num do
  new_doc = PDFDoc.new
  new_doc.InsertPages(0, doc, i, i, PDFDoc::E_none)
  new_doc.Save(output_filename + "_split_page_" + i.to_s + ".pdf", SDFDoc::E_linearized)
  new_doc.Close
end
```

{% endcode %}
{% endtab %}

{% tab title="VB" %}
{% code lineNumbers="true" %}

```vb
Dim doc4 As PDFDoc = New PDFDoc(filename)
Dim page_num As Integer = doc.GetPageCount()
For i = 1 To page_num
  Dim new_doc As PDFDoc = New PDFDoc()
  new_doc.InsertPages(0, doc, i, i, PDFDoc.InsertFlag.e_none)
  new_doc.Save(output_filename + "_split_page_" + CStr(i) + ".pdf", SDFDoc.SaveOptions.e_linearized)
  new_doc.Close()
Next i
```

{% endcode %}
{% endtab %}
{% endtabs %}

[Merge, Copy, Delete, and Rearrange PDF Pages](/core/get-started/samples/pdfpagetest.md) Full code sample which illustrates how to copy pages from one document to another, how to delete, and rearrange pages and how to use ImportPages(). Code sample is available in C++, C#, Java, Python, Go, PHP, Ruby & VB.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/core/page-manipulation/split.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
